/**
 * Benchmark Test Header file
 *
 * @author: W. David Frohlingsdorf
 * @date: 2016
 * @purpose: Dissertation, University of Glasgow
 * */

#include <pthread.h>

// * * Threads * * //
#define BENCHMARK_THREAD_TYPE          pthread_t
#define BENCHMARK_INIT_THREAD(id,func) ;
#define BENCHMARK_RUN_THREAD(id,func)  pthread_create(&id, NULL, func, NULL)
#define BENCHMARK_JOIN_THREAD(id)      pthread_join(id, NULL)
#define FUNC_ARG_TYPE                  void*
#define FUNC_RET_TYPE                  void*
#define FUNC_RET_VAL                   NULL
// * * Locks * * //
#define BENCHMARK_LOCK_TYPE            pthread_mutex_t
#define BENCHMARK_INIT_LOCK(id)        pthread_mutex_init(&id, &attr)
#define BENCHMARK_LOCK(id)             pthread_mutex_lock(&id)
#define BENCHMARK_UNLOCK(id)           pthread_mutex_unlock(&id)
// * * Globals * * //
#define GLOBAL_ATTR                    pthread_mutexattr_t attr;
#define GLOBAL_INIT()                  pthread_mutexattr_init(&attr); pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_RECURSIVE);
