import sys

#Arguments:
#1 firstCsvFile
#2 secondCsvFile
#3 Figure caption
#4 Figure label

#Hardcoded in file:
#  Size of test date (300)
#  Whiskers (2%, 97%)

def h(a, b):
  return ((a + b)/2.0)

def printBegin(caption, label):
  print("\\begin{figure}")
  print("\\caption{" + caption + "}")
  print("\\label{" + label + "}")
  print("\\begin{tikzpicture}")
  print("  \\begin{axis} [")
  print("      boxplot/draw direction=y,")
  print("      xlabel={Max. thread. \\textcolor{blue}{TM}, \\textcolor{red}{Inheritance Locks}},")
  print("      ylabel={Time needed [ns]},")
  print("      xtick={1.5,4.5,7.5,10.5,13.5},")
  print("      xticklabels={20,40,60,80,100},")
  print("    ]")

def printEnd():
  print("  \\end{axis}")
  print("\\end{tikzpicture}")
  print("\\end{figure}")

def spacePlot():
  print("    \\addplot+[boxplot prepared={")
  print("        lower whisker=0, lower quartile=0,")
  print("        median=0, upper quartile=0,")
  print("        upper whisker=0}, white, solid]")
  print("        coordinates {};")

def readCsvFile(name, colour):
  listOut = []
  with open(name) as f:
    l = f.readline()
  
    # Hardcoded variables
    # length for each = 300
    dic = {20:[], 40:[], 60:[], 80:[], 100:[]}

    l = f.readline()
    while l != "":
      trip = l.strip("\n").split(",")
      v = int(trip[0])
      k = int(trip[2])
      dic[k].append(v)
      l = f.readline()

    for k in sorted(dic.iterkeys()):
      v = dic[k]
      v.sort()
      median = h(v[150],v[151])
      lower = h(v[75],v[76])
      upper = h(v[225],v[226])
      lowWhisk = h(v[6],v[7])
      highWhisk = h(v[294], v[295])
      s = "    \\addplot+[boxplot prepared={\n"
      s += "        lower whisker="+str(lowWhisk)+", lower quartile="+str(lower)+",\n"
      s += "        median="+str(median)+", upper quartile="+str(upper)+",\n"
      s += "        upper whisker="+str(highWhisk)+"}, "+colour+", solid]\n"
      s += "        coordinates {};"    
      listOut.append(s)
  return listOut
  
#Main
blueData = readCsvFile(sys.argv[1], "blue")
redData = readCsvFile(sys.argv[2], "red")
first = True

printBegin(sys.argv[3], sys.argv[4])
for i in range(len(blueData)):
  if not first:
    spacePlot()
  else:
    first = False
  print(blueData[i])
  print(redData[i])
printEnd()
