#!/bin/bash

# This script runs a predefined times
# gimp with the simple-unsharp-mask
# script and compares the output.

#Arguments:
#1 library

RUNS=500

if [ -f temp.txt ]; then
  rm temp.txt
fi

for i in `seq 1 $RUNS`;
do
  cp wiki_backup.png wiki.png
  export LD_PRELOAD=$1
  gimp -i -b '(simple-unsharp-mask "wiki.png" 5.0 0.5 0)' -b '(gimp-quit 0)'
  cmp -i 100 -l wiki.png wiki_ref.png | gawk '{printf "%08X %02X %02X\n", $1, strtonum(0$2), strtonum(0$3)}' | wc -c >> temp.txt 
done

echo ""
echo " * * * * * * * * * * "
echo ""
echo "From $RUNS"
grep '^0$' temp.txt | wc -l
echo "were successful."
echo ""
echo " * * * * * * * * * * "
echo ""

rm temp.txt
