#!/bin/bash

#Arguments:
#1 = applicationName 
#2 = outputCsvFile 
#3 = max_locks 
#4 = max_threads_start 
#5 = max_threads_interval 
#6 = max_threads_iterations 
#7 = rounds

current_date="`date +%Y-%m-%d-%H:%M:%S`";
echo $current_date

#Setup make a clean working environment
for i in 5 10 15 25 50;
do
  cp resultsO3/clean.csv resultsO3/$i.locks/tm.csv
  cp resultsO3/clean.csv resultsO3/$i.locks/inherit.csv
done

for (( j=0; j<100; j++));
do
  for i in 5 10 15 25 50;
  do
    ./runExperiment.sh testTM resultsO3/$i.locks/tm.csv $i 10 10 10 10
    ./runExperiment.sh testInherit resultsO3/$i.locks/inherit.csv $i 10 10 10 10
  done
done


#Post processing
for i in 5 10 15 25 50;
do
  python resultsO3/stat.py resultsO3/$i.locks/tm.csv resultsO3/$i.locks/inherit.csv "Max $i locks" "fig.bench.tyche.optimised.res_$i.locks_01" > resultsO3/$i.locks.tex 
done

current_date="`date +%Y-%m-%d-%H:%M:%S`";
echo $current_date


