
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include "transfer.h"

    int accountBalance[] = {430, 1200}; /* Start amount in accounts */
const int FINALBALANCE[] = {330, 1300}; /* Expected final amount in accounts */
     const int NACCOUNTS = 2;
int logCount;
    const int NETWORK_IO = 5;
       const int TIMEOUT = 15;

LOCK_TYPE accountLock[2];

/* * * Prototypes * * */
void *transfer(void *);

int main()
{
  pthread_t thread1, thread2;
  int transfer1[] = {50, 1, 0};
  int transfer2[] = {150, 0, 1};
  int i;
  time_t start_time;
  logCount = 0;
  for(i = 0; i<NACCOUNTS; i++)
  {
    LOCK_INIT(accountLock[i]);
  }
  pthread_create(&thread1, NULL, transfer, (void *)(&transfer1));
  pthread_create(&thread2, NULL, transfer, (void *)(&transfer2));
  printf("Waiting for results...\n");
  start_time = time(NULL);
  while(logCount != 2)
  {
    if(difftime(time(NULL), start_time) >= TIMEOUT)
      break;
    sleep(1);
  }
  if(logCount != 2)
  {
    printf("Failure. Deadlocked!\n");
    printf("logCount = %d\n", logCount);
    printf("Expected: %4d - %4d\n", FINALBALANCE[0], FINALBALANCE[1]);
    printf("Actual:   %4d - %4d\n", accountBalance[0], accountBalance[1]);
  }
  else
  {
    if(FINALBALANCE[0] != accountBalance[0] || FINALBALANCE[1] != accountBalance[1])
    {
      printf("Failure. Incorrect result:\n");
      printf("Expected: %4d - %4d\n", FINALBALANCE[0], FINALBALANCE[1]);
      printf("Actual:   %4d - %4d\n", accountBalance[0], accountBalance[1]);
    }
    else
      printf("All fine.\n");
  }
  
  return 0;
}

void *transfer(void *param)
{
  int *record = (int *)(param);
  int s    = record[0];
  int from = record[1];
  int to   = record[2];
  LOCK(accountLock[from]);
  /* Maybe the transfer process got swapped out
   * or it needs to wait on the network interface.
   * This is an unexpected delay which might occur
   * in reality! */
  sleep(NETWORK_IO);
  LOCK(accountLock[to]);
  accountBalance[from] -= s;
  accountBalance[to] += s;
  UNLOCK(accountLock[to]);
  UNLOCK(accountLock[from]);
  logCount++;
  return NULL;
}
