/**
 * Simple error and trial program.
 * Thanks to:
 * http://blog.fesnel.com/blog/2009/08/25/preloading-with-multiple-symbol-versions/ 
 *
 * @author: W. David Frohlingsdorf
 * @date: 2017
 * @purpose: Dissertation, University of Glasgow
 * */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

static pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
static pthread_mutex_t mut = PTHREAD_MUTEX_INITIALIZER;

static volatile int okexit = 0;

void *thr_start(void *data)
{
    pthread_mutex_lock(&mut);
    while(!okexit)
        pthread_cond_wait(&cond, &mut);
    pthread_mutex_unlock(&mut);
    printf("Thread exiting\n");
    fflush(stdout);
    return NULL;
}

int main(int ac, char **av)
{
    pthread_t thr;
    if(pthread_create(&thr, NULL, thr_start, NULL) != 0) //Failed to start thread
        exit(EXIT_FAILURE);
    sleep(2);
    pthread_mutex_lock(&mut);
    okexit = 1;
    pthread_cond_signal(&cond);
    pthread_mutex_unlock(&mut);
    pthread_join(thr, NULL);
    return 0;
}
